<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <script src="{basePath}/svg-inject.min.js"></script>
    <script src="{basePath}/jquery-3.5.1.min.js"></script>
    <link rel="stylesheet" href="{basePath}/common.css">
    <link rel="stylesheet" href="{basePath}/historyViewDark.css">
    <link rel="stylesheet" href="{basePath}/bootstrap-4.5.2-dist/css/bootstrap.css">
</head>

<body>
    <div class="loadingContainer">
        <img src="{basePath}/../../resources/dark/loading.svg" style="stroke: white;" onload="SVGInject(this)" />
    </div>
    <table class="table" id="cartGrid" width="100%">
        <thead>
        </thead>
        <tbody>
        </tbody>
    </table>

    <script>
        var allRegisters_val = "";
        var No = 0;
        var theme = "";
        var address = "";
        var code = "";
        var ins = "";
        const vscode = acquireVsCodeApi();
        parser = new DOMParser();
        window.addEventListener('message', event => {
            const message = event.data;
            switch (message.type) {
                case 'stopLoading':
                    $('.loadingContainer').css('display', 'none');
                    break;
                case 'update':
                    xmlDoc = parser.parseFromString(message.xml, "text/xml");
                    let registersNode = xmlDoc.getElementsByTagName("registers")[0];
                    let disassembleNode = xmlDoc.getElementsByTagName("disasmCur")[0];
                    let temp = [];

                    if (registersNode != undefined) {
                        allRegisters_val = "";
                        for (let x = 0; x < registersNode.childNodes.length; x++) {
                            let node = registersNode.childNodes[x];
                            if (node.nodeType == Node.ELEMENT_NODE) {
                                let registerName = node.nodeName;
                                allRegisters_val += '<td>' + node.firstChild.nodeValue + '</td>';
                                if ($('#cartGrid th').length == 0) {
                                    theme += '<th>' + registerName + '</th>';
                                }

                            }
                        }
                    }

                    if (disassembleNode != undefined) {
                        for (let x = 0; x < disassembleNode.childNodes.length; x++) {
                            let node = disassembleNode.childNodes[x];
                            if (node.nodeType == Node.ELEMENT_NODE) {
                                temp = node.firstChild.nodeValue.split('!');
                                address = temp[0];
                                code = temp[1];
                                ins = temp[2];
                            }
                        }
                    }

                    if (allRegisters_val.length > 0 && address.length > 0) {
                        No++;
                        var date = new Date();
                        var str = '<td>' + No + '</td>' + '<td>' + date.getHours() + ":" + date.getMinutes() + ":" + date.getSeconds() + ":" + date.getMilliseconds() + '</td>' + '<td class="instructionCode">' + address + ":" + code + ":" + ins + '</td>' + allRegisters_val;
                        $('#cartGrid tbody').append('<tr>' + str + '</tr>');
                        allRegisters_val = "";
                        address = "";
                    }

                    if ($('#cartGrid th').length == 0 && theme.length > 0) {
                        $('.table thead').html($('.table thead').html() + '<tr>' + '<th scope="col">' + "No" + '</th>' + '<th scope="col">' + "Time" + '</th>' + '<th scope="col">' + "Instruction" + '</th>' + theme + '</tr>');
                    }

                    break;
            }
        })
    </script>
</body>

</html>